/*
package com.ywt.gateway.filter;



import org.reactivestreams.Publisher;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.gateway.filter.GatewayFilterChain;
import org.springframework.cloud.gateway.filter.GlobalFilter;
import org.springframework.cloud.gateway.filter.factory.rewrite.ModifyRequestBodyGatewayFilterFactory;
import org.springframework.cloud.gateway.filter.factory.rewrite.RewriteFunction;
import org.springframework.core.Ordered;
import org.springframework.core.io.buffer.DataBuffer;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.server.reactive.ServerHttpRequest;
import org.springframework.http.server.reactive.ServerHttpResponse;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;
import org.springframework.web.server.ServerWebExchange;
import reactor.core.publisher.Mono;

*/
/**
 * 自定义全局过滤器
 *//*

@Component
public class ActionFilter implements GlobalFilter, Ordered {
    private static final Logger log = LoggerFactory.getLogger(ActionFilter.class);

    @Autowired
    private ModifyRequestBodyGatewayFilterFactory factory;

    */
/**
     * 执行过滤器中的业务逻辑
     *
     * @param exchange
     * @param chain
     * @return
     *//*

    @Override
    public Mono<Void> filter(ServerWebExchange exchange, GatewayFilterChain chain) {
        String uuid = null;

        ServerHttpRequest request = exchange.getRequest();
        HttpHeaders headers = request.getHeaders();
        MediaType contentType = headers.getContentType();
        log.debug("请求报文类型: {}", getContentType(contentType));


        if (StringUtils.isEmpty(contentType)) {
            return sendError(exchange, HttpStatus.UNSUPPORTED_MEDIA_TYPE, null);
        }


        String uri = request.getPath().value();
        if (uri.contains("upload")){
            return chain.filter(exchange);
        }
        if (uri.contains("data")){
            return chain.filter(exchange);
        }
        if (uri.contains("download")){
            return chain.filter(exchange);
        }

        try {
            int of = uri.substring(1).indexOf("/");
            String origin = uri.substring(0, of + 1);
            log.debug("请求URI: {}", origin);
            if ("".equals(origin)) {
                return sendError(exchange, HttpStatus.NOT_FOUND, "未知的请求接口");
            }

            // 重写报文对象
            if (uri.startsWith("/esb/inbound")) {
               // response = servletUtils.getEsbRequest(exchange, getContentType(contentType), entry);
            }else if (uri.startsWith("/upsys/inbound")) {
                //response = servletUtils.getEntryXmlMsgRequest(exchange, getContentType(contentType), entry);
            } else {
                return sendError(exchange, HttpStatus.NOT_FOUND, "未知的请求接口");
            }

            // 将原报文放在entry中，并重写请求报文
            ModifyRequestBodyGatewayFilterFactory.Config config = new ModifyRequestBodyGatewayFilterFactory.Config();
            config.setRewriteFunction(String.class, String.class, new RequestRewriteFunction(new Object()));
            config.setContentType(MediaType.APPLICATION_JSON_VALUE);
            return factory.apply(config).filter(exchange, chain);
        } catch (Throwable e) {
            log.error("重定向请求异常", e);
            return sendError(exchange, HttpStatus.INTERNAL_SERVER_ERROR, null);
        }
    }



    private String getContentType(MediaType mediaType) {
        return String.join("/", mediaType.getType(), mediaType.getSubtype());
    }


    public Mono<Void> sendError(ServerWebExchange exchange, HttpStatus status, String message) {
        ServerHttpResponse response = exchange.getResponse();
        response.setStatusCode(status); // 设置响应码
        message = message == null ? "" : message.trim();
        DataBuffer wrap = response.bufferFactory().wrap(message.getBytes());
        return response.writeWith(Mono.just(wrap));
    }

    */
/**
     * 指定过滤器的执行顺序，数值越小，过滤器的优先级越高，越先执行
     *
     * @return
     *//*

    @Override
    public int getOrder() {
        return 1;
    }

    static class RequestRewriteFunction implements RewriteFunction<String, String> {
        private final Object entry;

        RequestRewriteFunction(Object entry) {
            this.entry = entry;
        }

        @Override
        public Publisher<String> apply(ServerWebExchange serverWebExchange, String body) {
            //String content = JSONObject.toJSONString(entry);
            return Mono.just(entry);
        }
    }

}
*/
